import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


/**
 * 
 * @author Harald Kranz
 *
 */

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		System.out.println("*******************************************");
		System.out.println("Beginn des Test");
		System.out.println("*******************************************");
		DFController dfcontroller = new DFController("E:\\DFComDLL.dll",10,254);		
		//DFController dfcontroller = new DFController("E:\\_E_Workspace\\DFComJava\\src\\res\\DFComDLL.dll",10,254);
		dfcontroller.comOpen("192.168.123.34");
		System.out.println("Verbindung zu dem Gert hergestellt");

		System.out.println("*******************************************");
		System.out.println("Test Message versenden");
		System.out.println("*******************************************");		
		try {
			if (dfcontroller.sendMessage("Zeile 1\rZeile 2\rZeile 3\r Zeile 4\rZeile 5", 20)== 1)
			{
				System.out.println("Message versendet OK");
			} else 
			{
				System.out.println("Message konnte nicht versendet werden");				
			}
		} catch (DFError e) {
			System.out.println(e.getMessage());
		}
		
		// Test Liste Datensatzbeschreibungen 
		System.out.println("*******************************************");
		System.out.println("Ausgabe der Liste Datensatzbeschreibungen");
		System.out.println("*******************************************");
		List<DFRecordDescription> lRecord = new ArrayList<DFRecordDescription>();
		try {
			lRecord = dfcontroller.readRecordDescription();
		} catch (DFError e) {
			e.getMessage();
		}
		for (int i = 0; i < lRecord.size(); i++)
			System.out.println(lRecord.get(i).toString());
		
		System.out.println("*******************************************");
		System.out.println("Ausgabe der Datenstze aus dem Gert"); 
		System.out.println("*******************************************");
		try {
			List<DFRecord> listRec = dfcontroller.readAllRecords();
			if (listRec!= null)
			{
				for (int i = 0;i < listRec.size();i++)
				{
			       System.out.println(listRec.get(i).getStringValue());
				}
			}
		} catch (DFError e) {
			System.out.println(e.getMessage());
		}
		
		// Test auslesen der Listenbeschreibungen 
		System.out.println("*******************************************");
		System.out.println("Ausgabe der Listenbeschreibungen");
		System.out.println("*******************************************");
		List<DFRecordDescription> lListRecord = new ArrayList<DFRecordDescription>();
		try {
			lListRecord = dfcontroller.readListDescription();
		} catch (DFError e) {
			e.getMessage();
		}
		for (int i = 0; i < lListRecord.size(); i++)
			System.out.println(lListRecord.get(i).toString());
		
		
		System.out.println("*******************************************");
		System.out.println("Listendaten auf das Gert bertragen");
		System.out.println("*******************************************");
		List<DFListRecord> dfListRecord = new ArrayList<DFListRecord>();
		try {
			dfListRecord = dfcontroller.readListData("E://Workspace_Austausch/_E_Workspace/DFComJava/src/res/");
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} catch (DFError e) {
			System.out.println(e.getMessage());
		}
		for (int i = 0; i < dfListRecord.size(); i++)
		{
			System.out.println(dfListRecord.get(i).getStringValue());
		}
		
		try {
			dfcontroller.writeLists("E:\\Workspace_Austausch\\_E_Workspace\\DFComJava\\src\\res\\Testsetup.aes", "E://_E_Workspace/DFComJava/src/res/");
			System.out.println("bertragen der Listen erfolgreich.");
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		} catch (DFError e) {
			System.out.println(e.getMessage());
		}
		
		dfcontroller.comClose();
		System.out.println("Verbindung getrennt Test beendet");
			    
	}

}
